%--- coordinate plot with respect to time
% you need to define model.C_posn in order to work properly

[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);

figure(1); clf; subplot(211);
figure(2); clf; subplot(211);
%--- plot true tracks
for i=1:total_tracks
    P= model.C_xy_posn*X_track(:,k_birth(i):1:k_death(i),i);
    figure(1); plot(k_birth(i):1:k_death(i),P(1,:),'-b'); hold on;
    figure(2); plot(k_birth(i):1:k_death(i),P(2,:),'-b'); hold on;
end;
%--- plot PHDs
line_sty1= {'-r','-g','-m','-y','-c'}; 
line_sty2= {'ro','gx','md','y+','c^'};
fig_handle= zeros(hat_total_track,1);
for i=1:hat_total_track
    cur_trk_no= hat_total_track_list(i);
    posn_old= [];
    for k=1:K
        idx= find(hat_track_list{k}==cur_trk_no);
        if ~isempty(idx),
            posn_new= model.C_xy_posn*hat_X{k}(:,idx);
            figure(1); ht= plot(k,posn_new(1),line_sty2{i}); fig_handle(i)= ht(1);
            figure(2); plot(k,posn_new(2),line_sty2{i});
            if ~isempty(posn_old)
                figure(1); plot((k-1):k,[ posn_old(1) posn_new(1) ], line_sty1{i});
                figure(2); plot((k-1):k,[ posn_old(2) posn_new(2) ], line_sty1{i});
            end;
            posn_old= model.C_xy_posn*hat_X{k}(:,idx); %update
        else
            posn_old= [];
        end;
    end;
end;

legend_title= cell(hat_total_track,1);
for i=1:hat_total_track
    legend_title{i}= ['birth time= ',num2str(hat_total_track_list(i))];
end;
figure(1); legend(fig_handle,legend_title);

%%--- plot PHDs
%for k=1:K
%    if ~isempty(hat_X{k})
%        P= model.C_posn*hat_X{k};
%        figure(1); plot(k,P(1,:),'r.'); 
%        figure(2); plot(k,P(2,:),'r.');
%    end;
%end;


figure(1); xlabel('time step','fontsize',15); ylabel('x','fontsize',15);
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 room_dim(1)]);
figure(2); xlabel('time step','fontsize',15); ylabel('y','fontsize',15);
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 room_dim(2)]);

%--- plot no. of targets
figure(3); clf;
plot(1:K,N_true); hold on;
plot(1:K,round(hat_N),'--r');
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 2]);