%---
%head_test1
head_test2

%--- signal generation
y= zeros(N,2,P);    %received signal
ys= zeros(N+h_len,2,P);   %received signal without noise
for n=1:Nspkr
    for p=1:P
        for el=1:(k_death(n)-k_birth(n))
            s_seg= s{n}( max([ 1 ((el-1)*Nframe-h_len+1) ]):(el*Nframe) );
            if length(s_seg)~=h_len,
                s_seg= [ zeros(h_len+Nframe-length(s_seg),1); s_seg ];
            end;
            yt= fftfilt(h{n}(:,1,p,el),s_seg);
            yt= yt( (h_len+1):(Nframe+h_len) );
            el2= el+k_birth(n)-1;
            ys((1+(el2-1)*Nframe):(el2*Nframe),1,p)= ys((1+(el2-1)*Nframe):(el2*Nframe),1,p)+yt;
            yt= fftfilt(h{n}(:,2,p,el),s_seg);
            yt= yt( (h_len+1):(Nframe+h_len) );
            ys((1+(el2-1)*Nframe):(el2*Nframe),2,p)= ys((1+(el2-1)*Nframe):(el2*Nframe),2,p)+yt;
        end;
        % el= k_death(n)- k_birth(n)+1
        el= k_death(n)- k_birth(n)+1; el2= el+k_birth(n)-1;
        s_seg= [ s{n}( ((el-1)*Nframe-h_len+1):(el*Nframe) ); zeros(h_len,1) ];
        yt= fftfilt(h{n}(:,1,p,el),s_seg); yt= yt( (h_len+1):length(yt) );
        ys((1+(el2-1)*Nframe):((el2-1)*Nframe+length(yt)),1,p)= ...
            ys((1+(el2-1)*Nframe):((el2-1)*Nframe+length(yt)),1,p)+yt;
        yt= fftfilt(h{n}(:,2,p,el),s_seg); yt= yt( (h_len+1):length(yt) );
        ys((1+(el2-1)*Nframe):((el2-1)*Nframe+length(yt)),2,p)= ...
            ys((1+(el2-1)*Nframe):((el2-1)*Nframe+length(yt)),2,p)+yt;
    end;
end;
        
ys_pow= sum(sum(sum(abs(ys(1:N,:,:)).^2)))/(N*2*P);
y= ys(1:N,:,:)+ randn(N,2,P)*sqrt(ys_pow/snr);

%--- xcorrelation computation
Sy1y2= cell(P,1);   %short-time cross spectral density between two microphones
for p=1:P
    Sy1y2{p}= st_xsd(y(:,1,p),y(:,2,p),Nframe,block_overlap);
end;
L= size(Sy1y2{1},2);   %no. of short-time frames

%generate a time interpolated DFT, partial on the TDOA range of interest
pts_per_sample= 8;
n_pts= -max_d:(1/pts_per_sample):max_d;
pDFT= zeros(length(n_pts),Nframe);  
for n=1:length(n_pts)
    temp= exp( -i*2*pi*(0:1:(Nframe/2))*n_pts(n)/Nframe );
    pDFT(n,:)= [ temp fliplr(conj(temp(2:(Nframe/2)))) ];
    %pDFT(n,:)= exp( i*2*pi*(0:1:(Nframe-1))*n_pts(n)/Nframe );
end;

cc= zeros(length(n_pts),L,P);     %cross correlation functions
for l=1:L
    for p=1:P
        Sy1y2{p}(:,l)= Sy1y2{p}(:,l)./abs(Sy1y2{p}(:,l));    %uncommenting this line leads to PHAT
        cc(:,l,p)= real(pDFT*Sy1y2{p}(:,l));
        %uncommenting the following line leads to normalization
        %cc(:,l,p)= cc(:,l,p)/norm(cc(:,l,p));
    end;
end;

%--- peak picking
max_peaks= 4;
upp_bound_factor= 0.25;
len_n_pts= length(n_pts);
peak_pt_indices= cell(L,P);
tdoa_peaks= cell(L,P);
for l=1:L
    for p=1:P
        %voice activity check by looking at power
        frame_pow= sum( y((1+(l-1)*Nframe):(l*Nframe),1,p ).^2 )+ ...
            sum( y((1+(l-1)*Nframe):(l*Nframe),2,p ).^2 );
        frame_pow= frame_pow/(2*Nframe);
        if frame_pow >= (ys_pow/snr),
            cc_temp= cc(:,l,p);
            diff1_cc= cc_temp(2:(len_n_pts-1))- cc_temp(1:(len_n_pts-2));
            diff2_cc= cc_temp(2:(len_n_pts-1))- cc_temp(3:len_n_pts);
            idx= find( diff1_cc>0 & diff2_cc>0 & cc_temp(2:(len_n_pts-1))>0 );
            idx= idx+1;
            if ~isempty(idx)
                [notused,idx2]= sort(-cc_temp(idx));
                idx= idx(idx2);
                if length(idx) > max_peaks,
                    idx= idx(1:max_peaks);
                end;
                threshold= upp_bound_factor*cc_temp(idx(1));
                %threshold= max([ upp_bound_factor*cc_temp(idx(1)) 100*Nframe*sigma_n^2 ]);
                idx2= find(cc_temp(idx)>= threshold);
                peak_pt_indices{l,p}= idx(idx2);
            end;
            tdoa_peaks{l,p}= n_pts(peak_pt_indices{l,p});
        else
            disp(['Signal too weak at ',num2str(l),'th frame of ',num2str(p),'th pair']);
        end;
    end;
end;

%--- compute true TDOAs
true_tdoa= zeros(L,P,Nspkr);
for n=1:Nspkr
    for p=1:P
        for el=k_birth(n):k_death(n)
            true_tdoa(el,p,n)= ...
                (norm( x_spkr(:,el,n)- x_sensor(:,2,p) )- norm( x_spkr(:,el,n)- x_sensor(:,1,p) ))/dR;
        end;
    end;
end;

%--- plot the cross correlation functions for visualization
figure(1); clf;
plot(y(:,1,1));

for p=1:Psensor
    figure(p+1); clf;
    pcolor(1:L,n_pts,cc(:,:,p));
    hold on;
    for n=1:Nspkr
        plot(k_birth(n):k_death(n),true_tdoa(k_birth(n):k_death(n),p,n),'w','linewidth',2);
    end;
    for el=1:L
        if ~isempty(tdoa_peaks{el,p}),
            plot(el,tdoa_peaks{el,p},'or');
            plot(el,tdoa_peaks{el,p}(1),'*r');
        end;
    end;
end;