close all; clear;

%--- do the TDOA estimation
disp('Generating TDOAs...');
tdoa_proc;

%---
disp('Start running simulation...');
max_posn_error= norm(room_dim);
no_of_trials= 100;
declare_problem_common;
d_wass2= zeros(K,1); %Wasserstein position error
d_wass1= zeros(K,1);
e_N= zeros(K,1);    %mean absolute number of sources error

for nn=1:no_of_trials
    disp([num2str(nn),'th trial']);
    declare_problem_two;
    two_filter_fast2; proc_idx;
    for k=1:K
        e_N(k)= e_N(k)+ abs(N_true(k)-hat_N(k));
        if ~isempty(X{k}) & ~isempty(hat_X{k}),
            d_wass2(k)= d_wass2(k)+ wasserstein_dist(model.C_posn*X{k},model.C_posn*hat_X{k});
        else
            d_wass2(k)= d_wass2(k)+ max_posn_error;
        end;
    end;
    declare_problem_single;
    single_filter;
    for k=1:K
        e_N(k)= e_N(k)+ abs(N_true(k)-hat_N(k));
        if ~isempty(X{k}) & ~isempty(hat_X{k}),
            d_wass1(k)= d_wass1(k)+ wasserstein_dist(model.C_posn*X{k},model.C_posn*hat_X{k});
        end;
    end;
end;

e_N= e_N/no_of_trials;
d_wass2= d_wass2/no_of_trials;
d_wass1= d_wass1/no_of_trials;

figure(1); clf;
plot(1:K,e_N);
ylabel('Mean absolute error of the target number estimate');
figure(2); clf;
plot(1:K,d_wass2); hold on;
plot(1:K,d_wass1,'r');
ylabel('Mean Wasserstein position error');
            