% fixed speaker location
% all the sensor pairs are in proximity, pretty much like what instant.
% approaches use.
%
% The results turn out to be not very good for simultaneous tracking

fcode='test1';

fs= 8000;     %sampling rate
Nspkr= 2;           %total no. of speakers
Nframe= 1024;   %channel impulse response update frame length
block_overlap= 1;   %block overlap factor for computing TDOAs
                    %always 1 for now
L= 45;              %no. of frames
N= L*Nframe;
Psensor= 6;           %no. of TDOA microphone pairs
P= Psensor;     %just for convenience of programming

snr_db= 100;
snr= 10^(snr_db/10);
Ts= 1/fs;


%--- parameters associated with room impulse responses
c= 344;			%speed of sound
rlim= 5;			%represent (but not exactly) the no. of multipaths
room_dim= [ 8; 5; 2.5 ];    %room size
beta= [ 0.85 0.85 0.75; 0.85 0.85 0.5 ];	%reflection coefficients of walls
%beta= 1e-6*ones(2,3);

%speaker coordinate
x_spkr= zeros(3,Nspkr); k_birth= zeros(Nspkr,1); k_death= zeros(Nspkr,1);
%speaker 1
k_birth(1)= 1; k_death(1)= 30;
x_spkr(:,1)= [ 1; 1; 1.8 ];
%speaker 2
k_birth(2)= 21; k_death(2)= 45;
x_spkr(:,2)= [ 4; 2; 1.8 ];

%sensor coordinates
x0= [ 0.001; 4.999; 1.8 ]; x_spc= .5;

x_sensor= zeros(3,P+1);
x_sensor(:,1)= x0;
x_sensor(:,2)= x0+ [ 0; -x_spc; 0 ];
x_sensor(:,3)= x0+ [ 0; -2*x_spc; 0 ];
x_sensor(:,4)= x0+ [ 0; -3*x_spc; 0 ];
x_sensor(:,5)= x0+ [ x_spc; 0; 0 ];
x_sensor(:,6)= x0+ [ 2*x_spc; 0; 0 ];
x_sensor(:,7)= x0+ [ 3*x_spc; 0; 0 ];

sensor_pair_idx= zeros(2,P);
sensor_pair_idx(:,1)= [ 1; 2 ];
sensor_pair_idx(:,2)= [ 2; 3 ];
sensor_pair_idx(:,3)= [ 3; 4 ];
sensor_pair_idx(:,4)= [ 1; 5 ];
sensor_pair_idx(:,5)= [ 5; 6 ];
sensor_pair_idx(:,6)= [ 6; 7 ];


dR= c*Ts;
max_d= ceil(x_spc/dR);       %max. no. of TDOA samples 

%---
h_len= 3000;      %length of room impulses responses

if exist(['roomir_',fcode,'.mat'],'file'), gen_ir= 'n'; 
else gen_ir= 'y'; end;

if gen_ir=='y',
    disp(['Computing the room impulse responses...']);
    h= cell(Nspkr,1);
    for n=1:Nspkr
        h{n}= zeros(h_len,P+1);
        for p=1:P+1
            h{n}(:,p)= ...
                ir_room2(x_spkr(:,n)/dR,x_sensor(:,p)/dR,room_dim/dR,beta,h_len,rlim);
        end;
    end;
    save( ['roomir_',fcode], 'h' );
else
    load(['roomir_',fcode]);
end;

%--- load speech signals
s= cell(Nspkr,1);
wav_file= cell(Nspkr,1);
wav_file{1}= 'si1752'; wav_file{2}= 'sx267_2';
for n=1:Nspkr
    st= wavread(wav_file{n}); st= decimate(st,2);
    sig_len= (k_death(n)-k_birth(n)+1)*Nframe;
    if length(st) > sig_len
        s{n}= st(1:sig_len);
    else
        s{n}= zeros(sig_len,1); s{n}(1:length(st))= st;
    end;
end;

%test: check out what happens when there is no signal
%t_len=length(s{1});
%s{1}= zeros(t_len,1);