% fixed speaker location
% all the sensor pairs are in proximity, pretty much like what instant.
% approaches use.
%
% The results turn out to be not very good for simultaneous tracking

fcode='test1';

fs= 8000;     %sampling rate
Nspkr= 3;           %total no. of speakers
Nframe= 1024;   %channel impulse response update frame length
block_overlap= 1;   %block overlap factor for computing TDOAs
                    %always 1 for now
L= 75;              %no. of frames
N= L*Nframe;
Psensor= 8;           %no. of TDOA microphone pairs
P= Psensor;     %just for convenience of programming
Pactual= 12;          %the actual total no. of microphones

snr_db= 20;
snr= 10^(snr_db/10);
Ts= 1/fs;


%--- parameters associated with room impulse responses
c= 344;			%speed of sound
rlim= 10;			%represent (but not exactly) the no. of multipaths
room_dim= [ 5; 3.5; 2.5 ];    %room size
beta= [ 0.99 0.99 0.8; 0.99 0.99 0.5 ];	%reflection coefficients of walls
%beta= 1e-6*ones(2,3);

%speaker coordinate
x_spkr= zeros(3,Nspkr); k_birth= zeros(Nspkr,1); k_death= zeros(Nspkr,1);
%speaker 1
k_birth(1)= 1; k_death(1)= 30;
x_spkr(:,1)= [ 1; 0.7; 1.8 ];
%speaker 2
k_birth(2)= 11; k_death(2)= 11+48;
x_spkr(:,2)= [ 4; 1; 1.8 ];
%speaker 3
k_birth(3)= 51; k_death(3)= 75;
x_spkr(:,3)= [ 3; 3.25; 1.8 ];


%sensor coordinates
x_sensor= zeros(3,Pactual);

epsi= 0.001; x_spc= 0.5; z_axis= 1.8;

x_sensor(:,1)= [ epsi; epsi; z_axis ];
x_sensor(:,2)= x_sensor(:,1)+ [ 0; x_spc; 0 ];
x_sensor(:,3)= x_sensor(:,1)+ [ x_spc; 0; 0 ];

x_sensor(:,4)= [ epsi; room_dim(2)-epsi; z_axis ];
x_sensor(:,5)= x_sensor(:,4)+ [ 0; -x_spc; 0 ];
x_sensor(:,6)= x_sensor(:,4)+ [ x_spc; 0; 0 ];

x_sensor(:,7)= [ room_dim(1)-epsi; room_dim(2)-epsi; z_axis ];
x_sensor(:,8)= x_sensor(:,7)+ [ 0; -x_spc; 0 ];
x_sensor(:,9)= x_sensor(:,7)+ [ -x_spc; 0; 0 ];

x_sensor(:,10)= [ room_dim(1)-epsi; epsi; z_axis ];
x_sensor(:,11)= x_sensor(:,10)+ [ 0; x_spc; 0 ];
x_sensor(:,12)= x_sensor(:,10)+ [ -x_spc; 0; 0 ];

sensor_pair_idx= zeros(2,P);
sensor_pair_idx(:,1)= [ 1; 2 ];
sensor_pair_idx(:,2)= [ 1; 3 ];
sensor_pair_idx(:,3)= [ 4; 5 ];
sensor_pair_idx(:,4)= [ 4; 6 ];
sensor_pair_idx(:,5)= [ 7; 8 ];
sensor_pair_idx(:,6)= [ 7; 9 ];
sensor_pair_idx(:,7)= [ 10; 11 ];
sensor_pair_idx(:,8)= [ 10; 12 ];


dR= c*Ts;
max_d= ceil(x_spc/dR);       %max. no. of TDOA samples 

%---
h_len= 3000;      %length of room impulses responses

if exist(['roomir_',fcode,'.mat'],'file'), gen_ir= 'n'; 
else gen_ir= 'y'; end;

if gen_ir=='y',
    disp(['Computing the room impulse responses...']);
    h= cell(Nspkr,1);
    for n=1:Nspkr
        h{n}= zeros(h_len,Pactual);
        for p=1:Pactual
            h{n}(:,p)= ...
                ir_room2(x_spkr(:,n)/dR,x_sensor(:,p)/dR,room_dim/dR,beta,h_len,rlim);
        end;
    end;
    save( ['roomir_',fcode], 'h' );
else
    load(['roomir_',fcode]);
end;

%--- load speech signals
s= cell(Nspkr,1);
wav_file= cell(Nspkr,1);
wav_file{1}= 'si1752'; wav_file{2}= 'sx267_2_double';
wav_file{3}= 'SA1';
for n=1:Nspkr
    st= wavread(wav_file{n}); st= decimate(st,2);
    sig_len= (k_death(n)-k_birth(n)+1)*Nframe;
    if length(st) > sig_len
        s{n}= st(1:sig_len);
    else
        s{n}= zeros(sig_len,1); s{n}(1:length(st))= st;
    end;
end;

%test: check out what happens when there is no signal
%t_len=length(s{1});
%s{1}= zeros(t_len,1);

s{2}= s{2}*1.5;
%s{3}= s{3}*1.5;