%--- coordinate plot with respect to time
% you need to define model.C_posn in order to work properly
file= 'exa3_1';

load([ '1filter_',file,'.mat']);

[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);


figure(1); clf; subplot(211);
figure(2); clf; subplot(211);
figure(3); clf;

%--- plot true tracks
for i=1:total_tracks
    P= model.C_posn*X_track(:,k_birth(i):1:k_death(i),i);
    figure(1); h1_t= plot(k_birth(i):1:k_death(i),P(1,:),'-k'); hold on;
    figure(2); h2_t= plot(k_birth(i):1:k_death(i),P(2,:),'-k'); hold on;
end;

%---- plot the existing single filter
%load 1filter_nice1.mat
%--- plot 1 filter
P= model.C_posn*hat_x;
figure(1); h1_1f= plot(1:K,P(1,:),':x'); 
figure(2); h2_1f= plot(1:K,P(2,:),':x');


%--- plot 2 filter
load([ '2filter_',file,'.mat']);

line_sty1= {'--ob','--sr','--^m','--+m','--g'}; 
fig_handle= zeros(hat_total_track,1);
for i=1:hat_total_track
    cur_trk_no= hat_total_track_list(i);
    
    k_present= []; posn_k_present= [];
    for k=1:K
        idx= find(hat_track_list{k}==cur_trk_no);
        if ~isempty(idx), 
            k_present= [ k_present k ];
            posn_k_present= [ posn_k_present model.C_xy_posn*hat_X{k}(:,idx) ];
        end;
    end;
    k_beg_idx= 1;
    for el=1:length(k_present)
        if (el > 1) & (k_present(el) ~= k_present(el-1)+1),
            figure(1); ht= plot( k_present(k_beg_idx:(el-1)), posn_k_present(1,k_beg_idx:(el-1)),line_sty1{i} );
            figure(2); plot( k_present(k_beg_idx:(el-1)), posn_k_present(2,k_beg_idx:(el-1)),line_sty1{i} );
            k_beg_idx= el;
        elseif el== length(k_present),
            figure(1); ht= plot( k_present(k_beg_idx:el), posn_k_present(1,k_beg_idx:el),line_sty1{i} );
            figure(2); plot( k_present(k_beg_idx:el), posn_k_present(2,k_beg_idx:el),line_sty1{i} );
        end;
    end;
    fig_handle(i)= ht(1);
    
    %figure(1); ht= plot(k_present,posn_k_present(1,:),line_sty1{i}); hold on;
    %figure_handle{i}= ht(1);
    %figure(2); plot(k_present,posn_k_present(2,:),line_sty1{i}); hold on;
    
    %posn_old= [];
    %for k=1:K
    %    idx= find(hat_track_list{k}==cur_trk_no);
    %    if ~isempty(idx),
    %        posn_new= model.C_xy_posn*hat_X{k}(:,idx);
    %        figure(1); ht= plot(k,posn_new(1),line_sty1{i}); fig_handle(i)= ht(1);
    %        figure(2); plot(k,posn_new(2),line_sty1{i});
    %        if ~isempty(posn_old)
    %            figure(1); plot((k-1):k,[ posn_old(1) posn_new(1) ], line_sty1{i});
    %            figure(2); plot((k-1):k,[ posn_old(2) posn_new(2) ], line_sty1{i});
    %        end;
    %        posn_old= model.C_xy_posn*hat_X{k}(:,idx); %update
    %    else
    %        posn_old= [];
    %    end;
    %end;
end;


figure(1); xlabel('time step','fontsize',15); ylabel('x (in m)','fontsize',15);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 room_dim(1)]);

% Get the legend done
final_fig_handle= zeros(3+hat_total_track,1);
legend_title= cell(3+hat_total_track,1);

final_fig_handle(1)= h1_t;
legend_title{1}= [ 'True (',num2str(total_tracks),' speakers in total)' ];
ht= plot(100,100,'w');   % make a fake point
final_fig_handle(2)= ht;
legend_title{2}= 'Multi-speaker RFS particle filter';
final_fig_handle(3:(hat_total_track+2))= fig_handle;
for i=1:hat_total_track
    legend_title{i+2}= ['     tag= ',num2str(hat_total_track_list(i))];
end;
final_fig_handle(hat_total_track+3)= h1_1f;
legend_title{hat_total_track+3}= 'Single-speaker particle filter';

figure(1); legend(final_fig_handle,legend_title,4);


%legend([ h1_t; h1_2f(1); h1_1f ],'True (2 speakers in total)','Multi-speaker RFS particle filter',...
%    'Single-speaker particle filter', 4);

figure(2); xlabel('time step','fontsize',15); ylabel('y (in m)','fontsize',15);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 room_dim(2)]);


%--- plot no. of targets
N_true= zeros(K,1);
for k=1:K
    N_true(k)= size(X{k},2);
end;
figure(3); subplot(211); 
plot(1:K,N_true,'-k'); hold on;
plot(1:K,round(hat_N),'b--o'); %,'Markersize',12); 
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 3]);
xlabel('time step','fontsize',15); ylabel('No. of active speakers','fontsize',15);
legend('True','Multi-speaker RFS particle filter');


