%--- coordinate plot with respect to time
% you need to define model.C_posn in order to work properly
file= 'exa3_1';

load([ '1filter_',file,'.mat']);

[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);


figure(1); clf; subplot(211);
figure(2); clf; subplot(211);
figure(3); clf;

%--- plot true tracks
for i=1:total_tracks
    P= model.C_posn*X_track(:,k_birth(i):1:k_death(i),i);
    figure(1); h1_t= plot(k_birth(i):1:k_death(i),P(1,:),'-k'); hold on;
    figure(2); h2_t= plot(k_birth(i):1:k_death(i),P(2,:),'-k'); hold on;
end;

%---- plot the existing single filter
%--- plot 1 filter
P= model.C_posn*hat_x;
figure(1); h1_1f= plot(1:K,P(1,:),':x'); 
figure(2); h2_1f= plot(1:K,P(2,:),':x');


% Get the legend done
final_fig_handle= zeros(2,1);
legend_title= cell(2,1);

final_fig_handle(1)= h1_t;
legend_title{1}= [ 'True (',num2str(total_tracks),' speakers in total)' ];
final_fig_handle(2)= h1_1f;
legend_title{2}= 'Single-speaker particle filter';

figure(1); legend(final_fig_handle,legend_title,4);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 room_dim(1)]);
xlabel('time step','fontsize',15); ylabel('x (in m)','fontsize',15);

figure(2); xlabel('time step','fontsize',15); ylabel('y (in m)','fontsize',15);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 room_dim(2)]);
xlabel('time step','fontsize',15); ylabel('y (in m)','fontsize',15);




