close all; clear;

%--- do the TDOA estimation
disp('Generating TDOAs...');
tdoa_proc;

%---
disp('Start running simulation...');
max_posn_error= norm(room_dim);
no_of_trials= 1000;
declare_problem_common;
d_wass2= zeros(K,1); %Wasserstein position error
d_wass1= zeros(K,1);
e_N= zeros(K,1);    %mean absolute number of sources error
Pc_N= zeros(K,1);   %probability that hat_N is correct

for nn=1:no_of_trials
    disp([num2str(nn),'th trial']);
    %--- two filter
    declare_problem_two;
    two_filter_fast2; proc_idx;
    for k=1:K
        e_N(k)= e_N(k)+ abs(N_true(k)-hat_N(k));
        if hat_N(k)== N_true(k),
            Pc_N(k)= Pc_N(k)+1;
            if ~isempty(X{k}) & ~isempty(hat_X{k}),
                d_wass2(k)= d_wass2(k)+ wasserstein_dist(model.C_posn*X{k},model.C_posn*hat_X{k});
            end;
        end;
    end;
    %--- one filter
    declare_problem_single;
    single_filter;
    for k=1:K
        if N_true(k)==1,
            d_wass1(k)= d_wass1(k)+ norm(model.C_posn*(hat_X{k}-X{k}));
        end;
    end;
end;

e_N= e_N/no_of_trials;
d_wass2= d_wass2./Pc_N;
Pc_N= Pc_N/no_of_trials;
d_wass1= d_wass1/no_of_trials;

figure(1); clf;
plot(1:K,e_N);
ylabel('Mean absolute error of the target number estimate');
figure(2); clf;
plot(1:K,Pc_N);
ylabel('Probability of Correct N');
figure(3); clf;
plot(1:K,d_wass2); 
hold on;
plot(1:K,d_wass1,'r');
%ylabel('Mean Wasserstein position error');

save result1.mat Ns K d_wass1 d_wass2 Pc_N e_N no_of_trials
            