function g= compute_likelihood(model,z,X,q)
% compute a likelihood function vector g= [ g(z|x_1), ... , g(z|x_M) ]
% this function is problem dependent
% this one is for TDOA measurement case
% index q stands for the qth sensor

M= size(X,2);
P0= model.C_posn*X- repmat(model.sensor_posns(1:2,1,q),[1 M]);  %coordinate associated with X
P1= model.C_posn*X- repmat(model.sensor_posns(1:2,2,q),[1 M]);
Phi= sqrt(sum(P1.^2))- sqrt(sum(P0.^2));
e_sq= ((repmat(z,[1 M])- Phi)./model.D).^2;
g= exp( -e_sq/2 )/(sqrt(2*pi)*model.D);
