%---
head_test1

%--- signal generation
y= zeros(N,2,P);    %received signal
ys= zeros(N,2,P);   %received signal without noise
ys_interp= zeros(interp_factor*N,2,P);
s_interp= interp(s,interp_factor);
for p=1:P
    ys_interp(:,1,p)= fftfilt(h(:,1,p),s_interp);
    ys(:,1,p)= decimate(ys_interp(:,1,p),interp_factor);
    ys_interp(:,2,p)= fftfilt(h(:,2,p),s_interp);
    ys(:,2,p)= decimate(ys_interp(:,2,p),interp_factor);
end;

ys_pow= sum(sum(sum(abs(ys).^2)))/(N*2*P);
y= ys+ randn(N,2,P)*sqrt(ys_pow/snr);

%--- xcorrelation computation
pts_per_sample= 4;
n_pts= -max_d:(1/pts_per_sample):max_d;
pDFT= zeros(length(n_pts),Nframe);  %time interpolated DFT, partial on the time range of interest
for n=1:length(n_pts)
    temp= exp( -i*2*pi*(0:1:(Nframe/2))*n_pts(n)/Nframe );
    pDFT(n,:)= [ temp fliplr(conj(temp(2:(Nframe/2)))) ];
    %pDFT(n,:)= exp( i*2*pi*(0:1:(Nframe-1))*n_pts(n)/Nframe );
end;

cc= zeros(length(n_pts),L,P);     %cross correlation functions
ncc= zeros(length(n_pts),L,P);    %normalized version of cc
for l=1:L
    for p=1:P
        S_xcor= fft(y((1+(l-1)*Nframe):(l*Nframe),1,p)) .* ...
            conj(fft(y((1+(l-1)*Nframe):(l*Nframe),2,p)));
        S_xcor= S_xcor./abs(S_xcor);    %uncommenting this line leads to PHAT
        cc(:,l,p)= real(pDFT*S_xcor);
        ncc(:,l,p)= cc(:,l,p)/norm(cc(:,l,p));
    end;
end;

%--- plot the cross correlation functions for visualization
l=1:L;
for p=1:P
    %true_tdoa= norm( x_s(1:2)- x_sensor(1:2,2,p) )- norm( x_s(1:2)- x_sensor(1:2,1,p) );
    true_tdoa= (norm( x_s(:)- x_sensor(:,2,p) )- norm( x_s(:)- x_sensor(:,1,p) ))/(c*Ts);
    figure(p); clf;
    subplot(211);   %
    pcolor(l,n_pts,ncc(:,:,p)); 
    hold on;
    plot(l,true_tdoa*ones(1,L),'k','linewidth',3);
    subplot(212);
    for w=1:L
        plot(n_pts,ncc(:,w,p)); hold on;
    end;
    temp_max= max(max(ncc(:,:,p)));  temp_min= min(min(ncc(:,:,p)));
    plot( [true_tdoa true_tdoa], [temp_min temp_max], 'r' );
end;