%--- difference from sigen_test1: set up some threshold
%---
head_test2

%--- signal generation
y= zeros(N,2,P);    %received signal
ys= zeros(N,2,P);   %received signal without noise
for k=1:K_spkr
for p=1:P
    ys(:,1,p)= ys(:,1,p)+ fftfilt(h(:,1,p,k),s(:,k));
    ys(:,2,p)= ys(:,2,p)+ fftfilt(h(:,2,p,k),s(:,k));
end;
end;

ys_pow= sum(sum(sum(abs(ys).^2)))/(N*2*P);
sigma_n= sqrt(ys_pow/snr);
y= ys+ randn(N,2,P)*sigma_n;

%--- xcorrelation computation
Y= cell(P,1);
for p=1:P
    yt= y(:,:,p);
    Y{p}= stft(yt,Nframe,block_overlap);
    Y{p}= Y{p}(:,2:(Nframe/2),:);           %take out DC and Nyguist
end;
[notused_is_2_anyway, notused_Nframe_over_2_minus_1, L]= size(Y{1});

%---generate a time interpolated DFT, partial on the TDOA range of interest
pts_per_sample= 8;
n_pts= -max_d:(1/pts_per_sample):max_d;
pDFT= zeros(length(n_pts),Nframe/2-1);  
for n=1:length(n_pts)
    temp= exp( -i*2*pi*(1:1:(Nframe/2-1))*n_pts(n)/Nframe );
    pDFT(n,:)= temp;
end;

%---alternating strategy
W= 3;
YY= Y;
tau= zeros(W,L,P);

for w=1:W
    
    cc= zeros(length(n_pts),L,P);
    for el=1:L
        for p=1:P
            cc(:,el,p)= real( pDFT*(transpose(YY{p}(1,:,el)).*ctranspose(YY{p}(2,:,el))) );
            [max_pt,idx]= max(cc(:,el,p)); idx= idx(1);
            tau(w,el,p)= n_pts(idx);
        end;
    end;
    
    for p=1:P
        figure(p+P*(w-1)); clf;
        pcolor(1:L,n_pts,cc(:,:,p)); shading interp;
        hold on;
        for k=1:K_spkr
            true_tdoa= (norm( x_s(:,k)- x_sensor(:,2,p) )- norm( x_s(:,k)- x_sensor(:,1,p) ))/dR;
            plot(1:L,true_tdoa*ones(1,L),'k','linewidth',2);
        end;
        for el=1:L
            plot(el,tau(w,el,p)*ones(1,L),'or');
        end;
    end;
    
    %if w==2, keyboard; end;

    
    %cancellation
    for p=1:P
        for el=1:L
            a= exp( i*2*pi*(1:1:(Nframe/2-1))*tau(w,el,p)/Nframe );
            hat_s= 0.5*( YY{p}(1,:,el)+ a.*YY{p}(2,:,el) );
            YY{p}(1,:,el)= YY{p}(1,:,el)- hat_s;
            YY{p}(2,:,el)= YY{p}(2,:,el)- conj(a).*hat_s;
            %disp('Press any key to continue');
            %pause
            %soundsc(real(ifft([0 hat_s 0 fliplr(hat_s) ])));
        end;
    end;
    disp('Press any key to continue');
    pause
end;