function Z= gen_observation(model,X,q)
% this observation generation function is for TDOA
% measurements. The index q stands for the qth sensor

if isempty(X),
    Z= [];
else
    P0= model.C_posn*X - repmat(model.sensor_posns(:,1,q),[1 size(X,2)]); %coordinate extraction
    P1= model.C_posn*X - repmat(model.sensor_posns(:,2,q),[1 size(X,2)]);
    Z= sqrt(sum(P1.^2))- sqrt(sum(P0.^2));
    Z= Z+ model.D*randn(1,size(X,2));
end;