%==== Multi-sensor 1 target Bayesian filtering:
% run this routine after you call 'declare_problem_single' and signal generation
% modification:
% 1. put index on it
% 2. put 'adaptive' P_D

P_D2_poor_res= 0.4;
P_D2_ok_res= 0.8;
tdoa_res= 3*dR;


%---
hat_N= zeros(K,1);      %(soft) estimate of the number of targets
particle_X= cell(K,1);  %cell for storing all particles
particle_X_idx= cell(K,1);
particle_W= cell(K,1);  %cell for storing the update weights
Xk= cell(Ns,1); Xk_idx= cell(Ns,1);
Wk= ones(Ns,1)/Ns;

for k=1:K
    k
    time_start= cputime;
    Xk_old= Xk; Xk_idx_old= Xk_idx;
    Xk= cell(Ns,1); Xk_idx= cell(Ns,1);
    for n=1:Ns
        % particle generation
        Nk_old= size(Xk_old{n},2);
        if Nk_old < 2,  %birth
            rv= rand;
            if rv <= P_birth,
                Xk{n}= [ Xk{n} gen_birthstate(model,1) ];
                Xk_idx{n}=[ Xk_idx{n} k ];
            end;
        end;
        for m=1:Nk_old
            rv= rand;
            if rv > P_death     %death
                Xk{n}= [ Xk{n} gen_newstate(model,Xk_old{n}(:,m)) ];
                Xk_idx{n}= [ Xk_idx{n} Xk_idx_old{n}(m) ];
            end;
        end;
        % weight update
        Nk= size(Xk{n},2);
        if Nk==1,
            for q=1:Q
                fzx= 0;
                for i=1:size(Z{q,k},2)
                    fzx= fzx+ compute_likelihood(model,Z{q,k}(:,i),Xk{n},q);
                end;
                Wk(n)= Wk(n)*( (1-P_D)+ P_D*fzx/(lambda_c/prod(range_c(:,2)-range_c(:,1))) );
            end;
        end;
        if Nk==2,
            for q=1:Q
                tdoa1= norm(Xk{n}(:,1)- model.sensor_posns(:,2,q))- ...
                    norm(Xk{n}(:,1)- model.sensor_posns(:,1,q));
                tdoa2= norm(Xk{n}(:,2)- model.sensor_posns(:,2,q))- ...
                    norm(Xk{n}(:,2)- model.sensor_posns(:,1,q));
                if abs(tdoa2-tdoa1) > tdoa_res,
                    P_D2= P_D2_ok_res;
                else
                    P_D2= P_D2_poor_res;
                end;
                fzx1= 0; fzx2= 0; fzx12= 0;
                for i=1:size(Z{q,k},2)
                    t1= compute_likelihood(model,Z{q,k}(:,i),Xk{n}(:,1),q);
                    t2= compute_likelihood(model,Z{q,k}(:,i),Xk{n}(:,2),q);
                    fzx1= fzx1+ t1;
                    fzx2= fzx2+ t2;
                    fzx12= fzx12+ t1*t2;
                end;
                Wk(n)= Wk(n)*( ...
                    ( (1-P_D2)+ P_D2*fzx1/(lambda_c/prod(range_c(:,2)-range_c(:,1))) )* ...
                    ( (1-P_D2)+ P_D2*fzx2/(lambda_c/prod(range_c(:,2)-range_c(:,1))) ) - ...
                    fzx12*(P_D2/(lambda_c/prod(range_c(:,2)-range_c(:,1))))^2 );
            end;
        end;
    end;
    % weight normalization and resampling
    Wk= Wk/sum(Wk);
    idx= resample(Wk,Ns);
    Wk= ones(Ns,1)/Ns;
    Xk_old= Xk; Xk_idx_old= Xk_idx;
    for n=1:Ns
        Xk{n}= Xk_old{idx(n)}; Xk_idx{n}= Xk_idx_old{idx(n)};
        particle_X{k}= [ particle_X{k} Xk{n} ];
        particle_X_idx{k}= [ particle_X_idx{k} Xk_idx{n} ];
    end;
    particle_W{k}= Wk;
    %hat_N(k)= size(particle_X{k},2)/Ns;
end;


        
