K= 40;
x_dim= 4;

Nframe= 1024;
Ts= 1/8000;
T= Nframe*Ts;

sigma_motion= 1;     %in m/s
beta_motion= 10;    %in 1/s

A0= [ 1 T; 0 exp(-beta_motion*T) ];                       
model.A= [ A0 zeros(2,2); zeros(2,2) A0 ];
B0= [ 0; sigma_motion*sqrt(1-exp(-2*beta_motion*T)) ];
model.B= [ B0 zeros(2,1); zeros(2,1) B0 ];
model.sigma_v= sigma_motion;

model.C_posn= [ 1 0 0 0; 0 0 1 0 ];

X= zeros(x_dim,K);
for k=2:K
    X(:,k)= model.A*X(:,k-1)+ model.sigma_v*model.B*randn(size(model.B,2),1);
end;

Px= model.C_posn*X;
figure(1); clf;
plot( Px(1,:), Px(2,:), '-o' );
xlabel('x (in m)','FontSize',14);
ylabel('y (in m)','FontSize',14);

%sx(-10,10); sy(-10,10);
